/*
 * i3dlib - image manipulation library
 *
 * Copyright (C) 2000-2006   Centre for Biomedical Image Analysis (CBIA)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * lab_nha_neighbourhood.cc
 *
 * Neighbourhood used in the labelled versions of the Nilsson-Heyden algorithm
 *
 * Martin Maka (xmaska@fi.muni.cz) 2006 - 2011
 */

#include "lab_nha_neighbourhood.h"

namespace i3d
{
	namespace fls
	{
		/////////////////////////////////////////////////////////////////
		//                                                             //
		//                  Class Lab_NHA_Neighbourhood                //
		//                                                             //
		/////////////////////////////////////////////////////////////////

		/**********************************************************************/

		Type::Size Lab_NHA_Neighbourhood::NumAvail(Type::Size i) 
		{
			Type::Size num = 0;

			Type::Size num_neigh;
			const Type::Size *indices = m_neigh_indices -> Indices(i, num_neigh);

			for (Type::Size j = 0; j < num_neigh; ++j)
			{
				if (m_labels[i] != m_labels[indices[j]])
				{
					++num;
				}
			}

			return num;
		}

		/**********************************************************************/

	} // namespace fls 

} // namespace i3d

